\name{Dinamica-package}
\alias{Dinamica-package}
\alias{Dinamica}
\docType{package}
\title{
  R communication with Dinamica EGO.
}
\description{
  Allow R to send and receive data to an instance of Dinamica EGO.
}
\details{
  To exchange information with a Dinamica EGO session, the user must
  first connect to the session:
    Dinamica::openSession( sessionName )
  then data can be exchanged by using:
    - sendNumber() / receiveNumber()
    - sendNumberVector() / receiveNumberVector()
    - sendLookupTable() / receiveLookupTable()
  sendXXX functions will send immediately (unless queue is full) and 
  receiveXXX functions will block until a response is available on 
  the queue. For further usage instructions, refer to 
  http://csr.ufmg.br/dinamica/dokuwiki/doku.php?id=externalcommunication
}
\author{
Romulo Fernandes Machado
Maintainer: Romulo Fernandes Machado <romulo@csr.ufmg.br>
}
\references{
}
\keyword{ package }
\seealso{
  http://csr.ufmg.br/dinamica/dokuwiki/doku.php?id=externalcommunication
}
\examples{
  \dontrun{
    Dinamica::openSession("DinamicaEGO")
    Dinamica::sendNumberVector(c(1:1024))
    Dinamica::receiveLookupTable()
  }
}
